unit View;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls,
  Buttons,StdCtrls, Grv, Menus,Gauges,About;
type
  TViewForm = class(TForm)
    SpeedBar: TPanel;
    OpenButton: TSpeedButton;
    SaveButton: TSpeedButton;
    PrintButton: TSpeedButton;
    ZoomButton: TSpeedButton;
    StatusLine: TPanel;
    PagePanel: TPanel;
    ReportView: TGReportViewer;
    ZoomMenu: TPopupMenu;
    N2: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N251: TMenuItem;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N1251: TMenuItem;
    N1501: TMenuItem;
    N1751: TMenuItem;
    N2001: TMenuItem;
    N2251: TMenuItem;
    N2501: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    SetupButton: TSpeedButton;
    FrameButton: TSpeedButton;
    FontButton: TSpeedButton;
    FontDialog: TFontDialog;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    ProgressPanel: TPanel;
    Gauge1: TGauge;
    StatusPanel: TPanel;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    Page1: TMenuItem;
    Format1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    PageSetup1: TMenuItem;
    Font1: TMenuItem;
    Frames1: TMenuItem;
    FirstPage1: TMenuItem;
    PreviousPage1: TMenuItem;
    NextPage1: TMenuItem;
    LastPage1: TMenuItem;
    GotoPage1: TMenuItem;
    N4: TMenuItem;
    Zoom1: TMenuItem;
    PageWidth1: TMenuItem;
    WholePage1: TMenuItem;
    N7: TMenuItem;
    N252: TMenuItem;
    N502: TMenuItem;
    N752: TMenuItem;
    N1002: TMenuItem;
    N1252: TMenuItem;
    N1502: TMenuItem;
    N1752: TMenuItem;
    N2002: TMenuItem;
    N2252: TMenuItem;
    N2502: TMenuItem;
    N8: TMenuItem;
    procedure PrevPage(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ZoomSet(Sender: TObject);
    procedure OpenFile(Sender: TObject);
    procedure SaveFile(Sender: TObject);
    procedure Print(Sender: TObject);
    procedure FirstPage(Sender: TObject);
    procedure NextPage(Sender: TObject);
    procedure LastPage(Sender: TObject);
    procedure ZoomMenuClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure SetupPage(Sender: TObject);
    procedure FrameSet(Sender: TObject);
    procedure FontSet(Sender: TObject);
    procedure ReportViewFontNameChange(Sender: TObject);
    procedure ReportViewPageChange(Sender: TObject; APage: Integer);
    procedure ReportViewPageLoading(Sender: TObject; APage: Integer);
    procedure ReportViewProgress(Sender: TObject; Progress: Integer);
    procedure ReportViewZoomFactorChange(Sender: TObject);
    procedure GotoPage1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ViewForm: TViewForm;

implementation
{$R *.DFM}

procedure TViewForm.PrevPage(Sender: TObject);
begin
  ReportView.PrevPage;
end;

procedure TViewForm.BitBtn1Click(Sender: TObject);
begin
 close;
end;

procedure TViewForm.ZoomSet(Sender: TObject);
var P:TPoint;
begin
    p.x:=0;p.y:=ZoomButton.Height;
    p:=ZoomButton.Clienttoscreen(p);
    ZoomMenu.Popup(p.x,p.y);
end;

procedure TViewForm.OpenFile(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    ReportView.FileName:=OpenDialog.FileName;
    Save1.Enabled:=true;
    Print1.Enabled:=true;
    Page1.Enabled:=true;
    Format1.Enabled:=true;
    SaveButton.Enabled:=true;
    PrintButton.Enabled:=true;
    SetupButton.Enabled:=true;
    FrameButton.Enabled:=true;
    FrameButton.Down:=true;
    FontButton.Enabled:=true;
    ZoomButton.Enabled:=true;
    SpeedButton4.Enabled:=true;
    SpeedButton5.Enabled:=true;
    SpeedButton6.Enabled:=true;
    SpeedButton7.Enabled:=true;
  end;
end;

procedure TViewForm.SaveFile(Sender: TObject);
var st:string;
begin
  if SaveDialog.Execute then
  begin
    st:=extractfileext(SaveDialog.FileName);
    if Uppercase(st)='.GRF' then ReportView.SaveAsReport(SaveDialog.FileName);
    if Uppercase(st)='.TXT' then ReportView.SaveAsTabDelimited(SaveDialog.FileName);
    if Uppercase(st)='.CSV' then ReportView.SaveAsCommaDelimited(SaveDialog.FileName);
    if Uppercase(st)='.RTF' then ReportView.SaveAsRTF(SaveDialog.FileName);
  end;
end;

procedure TViewForm.Print(Sender: TObject);
begin
      if PrintDialog.Execute then
      begin
        if PrintDialog.PrintRange=prAllPages then ReportView.PrintAll;
        if PrintDialog.PrintRange=prPageNums then ReportView.PrintFromTo(PrintDialog.FromPage,PrintDialog.ToPage);
      end;
end;

procedure TViewForm.FirstPage(Sender: TObject);
begin
  ReportView.FirstPage;
end;

procedure TViewForm.NextPage(Sender: TObject);
begin
  ReportView.NextPage;
end;

procedure TViewForm.LastPage(Sender: TObject);
begin
  ReportView.LastPage;
end;

procedure TViewForm.ZoomMenuClick(Sender: TObject);
var st:string;
    i:integer;
begin
with  ReportView do
begin
  st:=TMenuItem(Sender).Name ;
  if (st='N2') or (st='PageWidth1') then
  begin
   ZoomFactor:=zPageWidth;
  end
  else
  if (st='N5') or (st='WholePage1')then
  begin
    ZoomFactor:=zWholePage;
  end
  else
  begin
    i:=strtoint(copy(st,2,length(st)-2));
    case i of
      25:ZoomFactor:=z25;
      50:ZoomFactor:=z50;
      75:ZoomFactor:=z75;
      100:ZoomFactor:=z100;
      125:ZoomFactor:=z125;
      150:ZoomFactor:=z150;
      175:ZoomFactor:=z175;
      200:ZoomFactor:=z200;
      225:ZoomFactor:=z225;
      250:ZoomFactor:=z250;

    end;
  end;
end;
end;

procedure TViewForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case Key of
    33:ReportView.lPrevPage;
    34:ReportView.lNextPage;
  end;
  if (Key=VK_END) and (ssCtrl in Shift) then ReportView.LastPage;
  if (Key=VK_HOME) and (ssCtrl in Shift) then ReportView.FirstPage;
  if Key=VK_ESCAPE then ReportView.CancelMode:=true;
end;

procedure TViewForm.FormCreate(Sender: TObject);
var b:integer;
begin
end;

procedure TViewForm.SetupPage(Sender: TObject);
begin
  if Sender<>SetupButton then SetupButton.Down:=not SetupButton.Down;
  PageSetup1.Checked:=SetupButton.Down; 
  ReportView.SetupMode:=SetupButton.Down;
end;

procedure TViewForm.FrameSet(Sender: TObject);
begin
  if Sender<>FrameButton then FrameButton.Down:=not FrameButton.Down;
  Frames1.Checked:=FrameButton.Down; 
  ReportView.DrawFrames:=FrameButton.Down;
end;

procedure TViewForm.FontSet(Sender: TObject);
begin
  FontDialog.Font.Name:=ReportView._FontName;
  FontDialog.Font.Size:=ReportView._FontSize;

  If FontDialog.Execute then
  begin
    ReportView._FontName:=FontDialog.Font.Name;
    ReportView._FontSize:=FontDialog.Font.Size;
  end;
end;

procedure TViewForm.ReportViewFontNameChange(Sender: TObject);
begin
  FontButton.Caption:=' '+ReportView._FontName+','+IntToStr(ReportView._FontSize);
end;

procedure TViewForm.ReportViewPageChange(Sender: TObject; APage: Integer);
begin
  PagePanel.Caption:=' Page '+IntToStr(APage)
end;

procedure TViewForm.ReportViewPageLoading(Sender: TObject; APage: Integer);
begin
  PagePanel.Caption:=' Loading '+IntToStr(APage);
end;

procedure TViewForm.ReportViewProgress(Sender: TObject; Progress: Integer);
begin
  if Progress<0 then
  begin
    Gauge1.Visible:=false;
    StatusPanel.Caption:='';
  end
  else
  begin
    Gauge1.Visible:=true;
    Gauge1.Progress:=Progress;
    StatusPanel.Caption:=' Press ESC to cancel ...';
  end;
end;

procedure TViewForm.ReportViewZoomFactorChange(Sender: TObject);
begin
 case ReportView.ZoomFactor of
   zPageWidth:ZoomButton.Caption:='Page Width';
   zWholePage:ZoomButton.Caption:='Whole Page';
   z25:ZoomButton.Caption:='25%';
   z50:ZoomButton.Caption:='50%';
   z75:ZoomButton.Caption:='75%';
   z100:ZoomButton.Caption:='100%';
   z125:ZoomButton.Caption:='125%';
   z150:ZoomButton.Caption:='150%';
   z175:ZoomButton.Caption:='175%';
   z200:ZoomButton.Caption:='200%';
   z225:ZoomButton.Caption:='225%';
   z250:ZoomButton.Caption:='250%';
 end;
end;

procedure TViewForm.GotoPage1Click(Sender: TObject);
var st:string;
begin
  st:=IntToStr(ReportView.PageNumber);
  if InputQuery('Go to Page','Enter a page number :',st) then
  begin
    try
      ReportView.PageNumber:=StrToInt(st);
    except
      ShowMessage('Incorrect Page Number');
    end;
  end;
end;

procedure TViewForm.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TViewForm.About1Click(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

end.
